#include-once
#include <Constants.au3>



Opt("MustDeclareVars", 1)

Global $advapi32dll = DllOpen ("advapi32.dll")

If (Not IsDeclared ('NULL')) Then _
Global $NULL = Ptr (0)

Global Const $MAX_KEY_LENGTH = 255
Global Const $MAX_VALUE_NAME = 16383
Global Const $MAX_TREE_DEPTH = 512
Global Const $MAX_PATH = 260

Global Const $HKEY_CLASSES_ROOT	= 0x80000000
Global Const $HKEY_CURRENT_USER	= 0x80000001
Global Const $HKEY_LOCAL_MACHINE	= 0x80000002
Global Const $HKEY_USERS	= 0x80000003
Global Const $HKEY_PERFORMANCE_DATA	= 0x80000004
Global Const $HKEY_CURRENT_CONFIG	= 0x80000005
Global Const $HKEY_DYN_DATA	= 0x80000006

Global Const $REG_STANDARD_FORMAT = 1 ; The key or hive is saved in Windows NT format.
Global Const $REG_LATEST_FORMAT = 2  ; The key or hive is saved in Windows XP format. After the key or hive is saved in this format, it cannot be loaded on an earlier system.
Global Const $REG_NO_COMPRESSION = 4 ; The key or hive is saved with no compression. This option accommodates faster save operations.

Global Const $REG_OPTION_VOLATILE = 1
Global Const $REG_OPTION_NON_VOLATILE = 0
Global Const $REG_CREATED_NEW_KEY = 1
Global Const $REG_OPENED_EXISTING_KEY = 2
;~ Global Const $REG_NONE = 0
;~ Global Const $REG_SZ = 1
;~ Global Const $REG_EXPAND_SZ = 2
;~ Global Const $REG_BINARY = 3
Global Const $REG_DWORD_LITTLE_ENDIAN = 4
;~ Global Const $REG_DWORD = 4
;~ Global Const $REG_DWORD_BIG_ENDIAN = 5
;~ Global Const $REG_LINK = 6
;~ Global Const $REG_MULTI_SZ = 7
;~ Global Const $REG_RESOURCE_LIST = 8
;~ Global Const $REG_FULL_RESOURCE_DESCRIPTOR = 9
;~ Global Const $REG_RESOURCE_REQUIREMENTS_LIST = 10
Global Const $REG_QWORD_LITTLE_ENDIAN = 11
Global Const $REG_QWORD = 11
Global Const $REG_NOTIFY_CHANGE_NAME = 1
Global Const $REG_NOTIFY_CHANGE_ATTRIBUTES = 2
Global Const $REG_NOTIFY_CHANGE_LAST_SET = 4
Global Const $REG_NOTIFY_CHANGE_SECURITY = 8

Global Const $KEY_ALL_ACCESS = (0xF003F); Combines the STANDARD_RIGHTS_REQUIRED, KEY_QUERY_VALUE, KEY_SET_VALUE, KEY_CREATE_SUB_KEY, KEY_ENUMERATE_SUB_KEYS, KEY_NOTIFY, and KEY_CREATE_LINK access rights.
Global Const $KEY_CREATE_LINK = (0x0020); Reserved for system use.
Global Const $KEY_CREATE_SUB_KEY = (0x0004); Required to create a subkey of a registry key.
Global Const $KEY_ENUMERATE_SUB_KEYS = (0x0008); Required to enumerate the subkeys of a registry key.
Global Const $KEY_EXECUTE = (0x20019); Equivalent to KEY_READ.
Global Const $KEY_NOTIFY = (0x0010); Required to request change notifications for a registry key or for subkeys of a registry key.
Global Const $KEY_QUERY_VALUE = (0x0001); Required to query the values of a registry key.
Global Const $KEY_READ = (0x20019); Combines the STANDARD_RIGHTS_READ, KEY_QUERY_VALUE, KEY_ENUMERATE_SUB_KEYS, and KEY_NOTIFY values.
Global Const $KEY_SET_VALUE = (0x0002); Required to create, delete, or set a registry value.
Global Const $KEY_WOW64_32KEY = (0x0200); Indicates that an application on 64-bit Windows should operate on the 32-bit registry view. For more information, see Accessing an Alternate Registry View.
;This flag must be combined using the OR operator with the other flags in this table that either query or access registry values.

;Windows 2000:  This flag is not supported.
Global Const $KEY_WOW64_64KEY = (0x0100); Indicates that an application on 64-bit Windows should operate on the 64-bit registry view. For more information, see Accessing an Alternate Registry View.
;This flag must be combined using the OR operator with the other flags in this table that either query or access registry values.

;Windows 2000:  This flag is not supported.
Global Const $KEY_WRITE = (0x20006); Combines the STANDARD_RIGHTS_WRITE, KEY_SET_VALUE, and KEY_CREATE_SUB_KEY access rights.


; --- $FILETIME
Global Const $FILETIME = _
		'dword dwLowDateTime;'& _
		'dword dwHighDateTime;'

; --- $_SYSTEMTIME
Global Const $_SYSTEMTIME = _
		'ushort wYear;'& _
		'ushort wMonth;'& _
		'ushort wDayOfWeek;'& _
		'ushort wDay;'& _
		'ushort wHour;'& _
		'ushort wMinute;'& _
		'ushort wSecond;'& _
		'ushort wMilliseconds;'



Func RegCloseKey ($hKey)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegCloseKey', _
									'ptr', $hKey)    ; key handle
	Return $aRes[0]

EndFunc

Func RegCreateKey ($hKey, $sSubKey, $phkResult)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegCreateKeyW', _
									'ptr' , $hKey, _
									'wstr' , $sSubKey, _
									'ptr*', $phkResult)
	If (IsArray ($aRes)) Then
;~ 		ArrayDisplayEx ($aRes, 'RegCreateKey')
		$phkResult       = $aRes[3]
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegCreateKeyEx ($hKey, $sSubKey, $sClass, $dwOptions, $samDesired, $lpSecurityAttributes, ByRef $phkResult, ByRef $lpdwDisposition)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegCreateKeyExW', _
									'ptr'   , $hKey, _
									'wstr'   , $sSubKey, _
									'ptr'   , 0, _      ; reserved
									'wstr'   , $sClass, _
									'dword' , $dwOptions, _
									'dword' , $samDesired, _
									'ptr'   , $lpSecurityAttributes, _
									'ptr*'  , $phkResult, _
									'dword*', $lpdwDisposition)
	If (IsArray ($aRes)) Then
;~ 		ArrayDisplayEx ($aRes, 'RegCreateKeyEx')
		$phkResult       = $aRes[8]
		$lpdwDisposition = $aRes[9]
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegDeleteKey ($hKey, $sSubKey)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegDeleteKeyW', _
									'ptr', $hKey, _
									'wstr', $sSubKey)
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~  		ArrayDisplayEx ($aRes, 'RegDeleteKey')
	EndIf
	Return $aRes[0]

EndFunc

Func RegDeleteKeyEx ($hKey, $sSubKey, $samDesired)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegDeleteKeyExW', _
									'ptr'  , $hKey, _
									'wstr'  , $sSubKey, _
									'dword', $samDesired, _
									'dword', 0)
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~  		ArrayDisplayEx ($aRes, 'RegDeleteKeyEx')
		Return $aRes[0]
	Else
		Return @error
	EndIf


EndFunc

Func RegDeleteValue ($hKey, $sValueName)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegDeleteValueW', _
									'ptr', $hKey, _
									'wstr', $sValueName)
	If (IsArray ($aRes)) Then
;~  		ArrayDisplayEx ($aRes, 'RegDeleteValue')
	EndIf
	Return $aRes[0]

EndFunc

Func RegEnumKeyEx ($hKey, $dwIndex, ByRef $sName, ByRef $sClass, $lpstLastWriteTime)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegEnumKeyExW', _
									'ptr'   , $hKey, _
									'dword' , $dwIndex, _
									'wstr'   , $sName, _
									'dword*', 255, _
									'ptr'   , 0, _       ; reserved
									'wstr'   , $sClass, _
									'dword*', 260, _
									'ptr'   , $lpstLastWriteTime)    ; PFILETIME
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~ 		ArrayDisplayEx ($aRes, 'RegEnumKeyEx')
		$sName  = $aRes[3]
		$sClass = $aRes[6]
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegEnumValue ($hKey, $dwIndex, ByRef $sValueName, ByRef $lpType, ByRef $lpData, ByRef $cbData)

	$lpData = DllStructCreate ('byte lpData['&$cbData&'];')

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegEnumValueW', _
									'ptr'   , $hKey, _               ; key handle
									'dword' , $dwIndex, _            ; index of the value to be retrieved
									'wstr'  , '', _                  ; pointer to a buffer
									'dword*', 16383, _               ; size of the buffer
									'ptr'   , 0, _       ; reserved
									'dword*', $lpType, _             ; value type
									'ptr'   , DllStructGetPtr ($lpData, 'lpData'), _  ; value data
									'dword*', DllStructGetSize ($lpData))     ; size of value data
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~ 		ArrayDisplayEx ($aRes, 'RegEnumValue')
		$sValueName = $aRes[3]
		$lpType     = $aRes[6]
		$lpData     = BinaryToString (BinaryMid (DllStructGetData ($lpData, 'lpData'), 1, $aRes[8]-1))
		$cbData     = $aRes[8]-1
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegEnumValueEx ($hKey, $dwIndex, ByRef $stValueInfo)

	$stValueInfo = DllStructCreate ('wchar ValueName[16383];dword lpcchValueName;dword lpType;byte lpData[260];dword lpcbData;')
	DllStructSetData ($stValueInfo, 'lpcchValueName', 16383)
	DllStructSetData ($stValueInfo, 'lpcbData', 260)
	Local $aRes = DllCall ($advapi32dll, 'long', 'RegEnumValueW', _
									'ptr'  , $hKey, _               ; key handle
									'dword', $dwIndex, _            ; index of the value to be retrieved
									'ptr'  , DllStructGetPtr ($stValueInfo, 'ValueName'), _    ; pointer to a buffer
									'ptr'  , DllStructGetPtr ($stValueInfo, 'lpcchValueName'), _     ; size of the buffer
									'ptr'  , Ptr (0), _             ; reserved
									'ptr'  , DllStructGetPtr ($stValueInfo, 'lpType'), _
									'ptr'  , DllStructGetPtr ($stValueInfo, 'lpData'), _
									'ptr'  , DllStructGetPtr ($stValueInfo, 'lpcbData'))
;~ 	ArrayDisplayEx ($aRes, 'RegEnumValueEx')
;~ 	DllStructSetData ($stValueInfo, 'ValueName', $aRes[3])
;~ 	DllStructSetData ($stValueInfo, 'lpcchValueName', $aRes[4])
	Return $aRes[0]

EndFunc

Func RegReplaceKey ($hKey, $lpSubKey, $lpNewFile, $lpOldFile)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegReplaceKeyW', _
									'ptr', $hKey, _
									'wstr', $lpSubKey, _
									'wstr', $lpNewFile, _
									'wstr', $lpOldFile)
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~  		ArrayDisplayEx ($aRes, 'RegReplaceKey')
	EndIf
	Return $aRes[0]

EndFunc

Func RegRestoreKey ($hKey, $lpFile, $dwFlags)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegRestoreKeyW', _
									'ptr'  , $hKey, _
									'wstr'  , $lpFile, _
									'dword', $dwFlags)
	If (IsArray ($aRes)) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~  		ArrayDisplayEx ($aRes, 'RegRestoreKey')
	EndIf
	Return $aRes[0]

EndFunc

Func RegOpenKeyEx ($hKey, $sSubKey, $samDesired, ByRef $phkResult)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegOpenKeyExW', _
									'ptr'  , $hKey, _            ; key handle
									'wstr'  , $sSubKey, _         ; subkey
									'dword', 0, _                ; reserved
									'dword', $samDesired, _      ; desired access rights to the key
									'ptr*'  , $phkResult)        ; pointer to a variable that receives a handle to the key
	If (IsArray ($aRes) And $aRes[0] == 0) Then
;~ 		DisplayErrorMessage ('RegDeleteKeyEx', $aRes[0], 1)
;~  	ArrayDisplayEx ($aRes, 'RegOpenKeyEx')
		$phkResult = $aRes[5]
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegQueryInfoKey ($hKey, ByRef $sClass, ByRef $lpcSubKeys, ByRef $lpcMaxSubKeyLen, ByRef $lpcMaxClassLen, _
		ByRef $lpcValues, ByRef $lpcMaxValueNameLen, ByRef $lpcMaxValueLen, ByRef $lpcbSecurityDescriptor, $lpftLastWriteTime)


	Local $aRes = DllCall ($advapi32dll, 'long', 'RegQueryInfoKeyW', _
									'ptr'   , $hKey, _                       ; key handle
									'wstr'   , '', _                          ; buffer for class name
									'dword*', 260, _                         ; size of class string
									'ptr'   , 0, _    ; reserved
									'dword*', $lpcSubKeys, _                 ; number of subkeys
									'dword*', $lpcMaxSubKeyLen, _            ; longest subkey size
									'dword*', $lpcMaxClassLen, _             ; longest class string
									'dword*', $lpcValues, _                  ; number of values for this key
									'dword*', $lpcMaxValueNameLen, _         ; longest value name
									'dword*', $lpcMaxValueLen, _             ; longest value data
									'dword*', $lpcbSecurityDescriptor, _     ; security descriptor
									'ptr'   , $lpftLastWriteTime)            ; last write time
	If (IsArray ($aRes)) Then
;~ 		ArrayDisplayEx ($aRes, 'RegQueryInfoKey')
		$sClass                 = $aRes[2]
		$lpcSubKeys             = $aRes[5]
		$lpcMaxSubKeyLen        = $aRes[6]
		$lpcMaxClassLen         = $aRes[7]
		$lpcValues              = $aRes[8]
		$lpcMaxValueNameLen     = $aRes[9]
		$lpcMaxValueLen         = $aRes[10]
		$lpcbSecurityDescriptor = $aRes[11]
	EndIf

	$NULL = Ptr (0)

	Return $aRes[0]

EndFunc

Func RegQueryInfoKeyEx ($hKey, ByRef $stKeyInfo)

	Local $stFileTime, $aRes

	If (IsDllStruct ($stKeyInfo)) Then _
		$stKeyInfo = 0

	$stKeyInfo = DllStructCreate ( _
				'wchar    ClassName[260];'& _      ; buffer for class name
				'dword    cchClassName;'& _         ; size of class string
				'dword    cSubKeys;'& _             ; number of subkeys
				'dword    cbMaxSubKey;'& _          ; longest subkey size
				'dword    cchMaxClass;'& _          ; longest class string
				'dword    cValues;'& _              ; number of values for key
				'dword    cchMaxValue;'& _          ; longest value name
				'dword    cbMaxValueData;'& _       ; longest value data
				'dword    cbSecurityDescriptor;'& _ ; size of security descriptor
				'ushort   wYear;'& _                ; last write time
				'ushort   wMonth;'& _
				'ushort   wDayOfWeek;'& _
				'ushort   wDay;'& _
				'ushort   wHour;'& _
				'ushort   wMinute;'& _
				'ushort   wSecond;'& _
				'ushort   wMilliseconds;' _
				)
	DllStructSetData ($stKeyInfo, 'cchClassName', 260)

	$stFileTime = DllStructCreate ('dword    dwLowDateTime;'& _        ; last write time
			 				 'dword    dwHighDateTime;')

	$aRes = DllCall ($advapi32dll, 'long', 'RegQueryInfoKeyW', _
								'ptr', $hKey, _                       ; key handle
								'ptr', DllStructGetPtr ($stKeyInfo, 'ClassName'), _             ; buffer for class name
								'ptr', DllStructGetPtr ($stKeyInfo, 'cchClassName'), _          ; size of class string
								'ptr', Ptr (0), _                     ; reserved
								'ptr', DllStructGetPtr ($stKeyInfo, 'cSubKeys'), _              ; number of subkeys
								'ptr', DllStructGetPtr ($stKeyInfo, 'cbMaxSubKey'), _           ; longest subkey size
								'ptr', DllStructGetPtr ($stKeyInfo, 'cchMaxClass'), _           ; longest class string
								'ptr', DllStructGetPtr ($stKeyInfo, 'cValues'), _               ; number of values for this key
								'ptr', DllStructGetPtr ($stKeyInfo, 'cchMaxValue'), _           ; longest value name
								'ptr', DllStructGetPtr ($stKeyInfo, 'cbMaxValueData'), _        ; longest value data
								'ptr', DllStructGetPtr ($stKeyInfo, 'cbSecurityDescriptor'), _  ; security descriptor
								'ptr', DllStructGetPtr ($stFileTime))                           ; last write time

	If (IsArray ($aRes)) Then _
		DllCall ('kernel32.dll', 'int', 'FileTimeToSystemTime', _
									'ptr', DllStructGetPtr ($stFileTime), _
									'ptr', DllStructGetPtr ($stKeyInfo, 'wYear'))

	Return $aRes[0]

EndFunc

Func RegSaveKey ($hKey, $sFile, $lpSecurityAttributes)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegSaveKeyW', _
									'ptr', $hKey, _
									'wstr', $sFile, _
									'ptr', $lpSecurityAttributes)
	If (IsArray ($aRes)) Then
;~  		ArrayDisplayEx ($aRes, 'RegSaveKey')
	EndIf
	Return $aRes[0]

EndFunc

Func RegSaveKeyEx ($hKey, $lpFile, $lpSecurityAttributes, $Flags)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegSaveKeyExW', _
									'ptr'  , $hKey, _
									'wstr'  , $lpFile, _
									'ptr'  , $lpSecurityAttributes, _
									'dword', $Flags)
	Return $aRes[0]

EndFunc

Func RegSetValueEx ($hKey, $sValueName, $dwType, ByRef Const $lpData, $cbData)

	Local $aRes = DllCall ($advapi32dll, 'long', 'RegSetValueExW', _
									'ptr', $hKey, _
									'wstr', $sValueName, _
									'ptr', 0, _      ; reserved
									'dword', $dwType, _
									'ptr'  , $lpData, _
									'dword', $cbData)
	Return $aRes[0]

EndFunc



